Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.jasperreports.engine.query
Class JRAbstractQueryExecuter

    java.lang.Object
      net.sf.jasperreports.engine.query.JRAbstractQueryExecuter

All Implemented Interfaces:
  JRQueryExecuter

Direct Known Subclasses:
  JRHibernateQueryExecuter, JRJdbcQueryExecuter, JRJpaQueryExecuter, JRMondrianQueryExecuter, JRXmlaQueryExecuter, JRXPathQueryExecuter

    public abstract class JRAbstractQueryExecuter

extends java.lang.Object
implements JRQueryExecuter

Base abstract query executer.

Version:
  $Id: JRAbstractQueryExecuter.java 3034 2009-08-27 11:58:04Z teodord $
Author:
  Lucian Chirita (lucianc@users.sourceforge.net)

Nested Class Summary
`protected static class` | `JRAbstractQueryExecuter.QueryParameter` A parameter present in the query.

Field Summary
`protected static int` | `CLAUSE_POSITION_ID`
`protected java.util.Map` | `clauseFunctions` Clause function registry.
`protected JRDataset` | `dataset`

Constructor Summary
`protected` | `JRAbstractQueryExecuter(JRDataset dataset, java.util.Map parametersMap)`

Method Summary
`protected void` | `addQueryMultiParameters(java.lang.String parameterName, int count)` Records a multi-valued query parameter.
`protected void` | `addQueryParameter(java.lang.String parameterName)` Records a query parameter.
`protected void` | `appendClauseChunk(java.lang.StringBuffer sbuffer, java.lang.String[] clauseTokens)` Handles a `clause query chunk`.
`protected void` | `appendParameterChunk(java.lang.StringBuffer sbuffer, java.lang.String chunkText)`
`protected void` | `appendParameterClauseChunk(java.lang.StringBuffer sbuffer, java.lang.String chunkText)`
`protected void` | `appendQueryChunk(java.lang.StringBuffer sbuffer, JRQueryChunk chunk)`
`protected void` | `appendTextChunk(java.lang.StringBuffer sbuffer, java.lang.String text)`
`protected void` | `applyClause(JRClauseFunction function, JRClauseTokens tokens, java.lang.StringBuffer sbuffer)`
`protected void` | `checkParameter(java.lang.String parameterName)`
`protected java.util.List` | `getCollectedParameterNames()` Returns the list of parameter names in the order in which they appear in the query.
`protected java.util.List` | `getCollectedParameters()` Returns the list of `query parameters` in the order in which they appear in the query.
`protected JRFillParameter` | `getParameter(java.lang.String parameterName)` Deprecated. `getValueParameter(String)` should be used instead
`protected abstract java.lang.String` | `getParameterReplacement(java.lang.String parameterName)` Returns the replacement text for a query paramter.
`protected java.lang.Object` | `getParameterValue(java.lang.String parameterName)` Returns the value of a fill paramter.
`protected java.lang.Object` | `getParameterValue(java.lang.String parameterName, boolean ignoreMissing)` Returns the value of a fill paramter.
`protected java.lang.String` | `getQueryString()` Returns the parsed query string with the paramter clauses replaced by the paramter values and the parameters replaced by `getParameterReplacement`.
`protected JRValueParameter` | `getValueParameter(java.lang.String parameterName)` Return a value parameter from the parameters map.
`protected JRValueParameter` | `getValueParameter(java.lang.String parameterName, boolean ignoreMissing)` Return a value parameter from the paramters map.
`protected void` | `parseQuery()` Parses the query and replaces the parameter clauses by the paramter values and the parameters by the return value of `getParameterReplacement`.
`protected void` | `registerClauseFunction(java.lang.String id, JRClauseFunction function)` Registers a clause function.
`protected JRClauseFunction` | `resolveFunction(java.lang.String id)` Resolves a clause function ID to a function instance.
`protected void` | `unregisterClauseFunction(java.lang.String id)` Unregisters a clause function.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface net.sf.jasperreports.engine.query.JRQueryExecuter
`cancelQuery, close, createDatasource`

Field Detail

### CLAUSE_POSITION_ID

    protected static final int CLAUSE_POSITION_ID

See Also:
  Constant Field Values

### clauseFunctions

    protected final java.util.Map clauseFunctions

  Clause function registry.

### dataset

    protected final JRDataset dataset

Constructor Detail

### JRAbstractQueryExecuter

    protected JRAbstractQueryExecuter(JRDataset dataset,
                                      java.util.Map parametersMap)

Method Detail

### registerClauseFunction

    protected void registerClauseFunction(java.lang.String id,
                                          JRClauseFunction function)

  Registers a clause function.

  Parameters:
    `id` - the function ID
    `function` - the function

### unregisterClauseFunction

    protected void unregisterClauseFunction(java.lang.String id)

  Unregisters a clause function.

  Parameters:
    `id` - the function ID

### resolveFunction

    protected JRClauseFunction resolveFunction(java.lang.String id)

  Resolves a clause function ID to a function instance.

  Parameters:
    `id` - the function ID
  Returns:
    the clause function registered for the ID
  Throws:
    `JRRuntimeException` - if no function for the ID is found

### parseQuery

    protected void parseQuery()

  Parses the query and replaces the parameter clauses by the paramter values and the parameters by the return value of `getParameterReplacement`.

### appendQueryChunk

    protected void appendQueryChunk(java.lang.StringBuffer sbuffer,
                                    JRQueryChunk chunk)

### appendTextChunk

    protected void appendTextChunk(java.lang.StringBuffer sbuffer,
                                   java.lang.String text)

### appendParameterChunk

    protected void appendParameterChunk(java.lang.StringBuffer sbuffer,
                                        java.lang.String chunkText)

### addQueryParameter

    protected void addQueryParameter(java.lang.String parameterName)

  Records a query parameter.

  Parameters:
    `parameterName` - the parameter name
  See Also:
    `getCollectedParameters()`

### addQueryMultiParameters

    protected void addQueryMultiParameters(java.lang.String parameterName,
                                           int count)

  Records a multi-valued query parameter.

  Parameters:
    `parameterName` - the parameter name
    `count` - the value count
  See Also:
    `getCollectedParameters()`, `JRAbstractQueryExecuter.QueryParameter.isMulti()`

### appendParameterClauseChunk

    protected void appendParameterClauseChunk(java.lang.StringBuffer sbuffer,
                                              java.lang.String chunkText)

### appendClauseChunk

    protected void appendClauseChunk(java.lang.StringBuffer sbuffer,
                                     java.lang.String[] clauseTokens)

  Handles a `clause query chunk`.

  The default implementation considers the first token as a `clause function` ID and delegates the call to the function.

  Extending query executers can override this to implement custom query clause handling.

  Parameters:
    `sbuffer` - the query text buffer
    `clauseTokens` - clause tokens
  Throws:
    `JRRuntimeException` - if there is no first token or no clause function is found for the ID
  See Also:
    `registerClauseFunction(String, JRClauseFunction)`

### applyClause

    protected void applyClause(JRClauseFunction function,
                               JRClauseTokens tokens,
                               java.lang.StringBuffer sbuffer)

### getQueryString

    protected java.lang.String getQueryString()

  Returns the parsed query string with the paramter clauses replaced by the paramter values and the parameters replaced by `getParameterReplacement`.

  Returns:
    the parsed query string

### getCollectedParameterNames

    protected java.util.List getCollectedParameterNames()

  Returns the list of parameter names in the order in which they appear in the query.

  Returns:
    the list of parameter names

### getCollectedParameters

    protected java.util.List getCollectedParameters()

  Returns the list of `query parameters` in the order in which they appear in the query.

  Returns:
    the list of query parameters

### getParameterValue

    protected java.lang.Object getParameterValue(java.lang.String parameterName,
                                                 boolean ignoreMissing)

  Returns the value of a fill paramter.

  Parameters:
    `parameterName` - the paramter name
    `ignoreMissing` - if `true`, the method will return null for non existing parameters; otherwise, an exception will be thrown if the parameter does not exist
  Returns:
    the parameter value

### getParameterValue

    protected java.lang.Object getParameterValue(java.lang.String parameterName)

  Returns the value of a fill paramter.

  Parameters:
    `parameterName` - the paramter name
  Returns:
    the parameter value

### getParameter

    protected JRFillParameter getParameter(java.lang.String parameterName)

  Deprecated. `getValueParameter(String)` should be used instead

  Return a fill parameter from the paramter map.

  Parameters:
    `parameterName` - the paramter name
  Returns:
    the parameter

### checkParameter

    protected void checkParameter(java.lang.String parameterName)

### getValueParameter

    protected JRValueParameter getValueParameter(java.lang.String parameterName,
                                                 boolean ignoreMissing)

  Return a value parameter from the paramters map.

  Parameters:
    `parameterName` - the paramter name
    `ignoreMissing` - if `true`, the method will return null for non existing parameters; otherwise, an exception will be thrown if the parameter does not exist
  Returns:
    the parameter

### getValueParameter

    protected JRValueParameter getValueParameter(java.lang.String parameterName)

  Return a value parameter from the parameters map.

  Parameters:
    `parameterName` - the parameter name
  Returns:
    the parameter

### getParameterReplacement

    protected abstract java.lang.String getParameterReplacement(java.lang.String parameterName)

  Returns the replacement text for a query paramter.

  Parameters:
    `parameterName` - the paramter name
  Returns:
    the replacement text
  See Also:
    `JRQueryChunk.TYPE_PARAMETER`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

© 2001-2010 Jaspersoft Corporation www.jaspersoft.com